import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Ball here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Ball extends MovingThing
{
    int hp=20;
    int dmg=10;
    public Ball()
    {
        setRotation(Greenfoot.getRandomNumber(360));
        int r=Greenfoot.getRandomNumber(56-dmg)+dmg;
        getImage().scale(r,r);
    }
    public Ball(int direction, int health)
    {
        setRotation(direction);
        hp=health;
        getImage().scale(getImage().getWidth()-health,getImage().getHeight()-health);
    }
    public void act() 
    {
        move(3);
        if(atWorldEdge()){
            move(-3);
            turn(153);
        }
        bounce();
        destroy();
    }
    public void bounce()
    {
        if(canSee(Ball.class))
        {
            turn(189);
            //Greenfoot.playSound("Pop.wav");
            move(3);
        }
        if(canSee(BallMobile.class))
        {
            turn(164);
            move(3);
        }
        if(canSee(AstroBall.class))
        {
            turn(178);
            move(3);
        }
        if(canSee(KillerBall.class))
        {
            turn(145);
            move(3);
        }
    }
    public void destroy()
    {
        Actor bullet;
        bullet = getOneObjectAtOffset ( 0, 0, Bullet.class );
        if(bullet != null)
        {
            int nhp=hp+dmg;
            //Greenfoot.playSound("Fire.wav");
            World world;
            world = getWorld();
            world.removeObject(bullet);
            Worldy worldy = (Worldy) getWorld();
            worldy.score(0-getImage().getWidth());
            worldy.addPoints(0-getImage().getWidth());
            if(nhp<50){
                getWorld().addObject(new Ball(315, nhp),getX()+10,getY()-10);
                getWorld().addObject(new Ball(45, nhp),getX()+10,getY()+10);
                getWorld().addObject(new Ball(135, nhp),getX()-10,getY()+10);
                getWorld().addObject(new Ball(225, nhp),getX()-10,getY()-10);
            }
            if(nhp==50){
                worldy.addD();
            }
            getWorld().removeObject(this);
        }
    }
}
