import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Ball here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class KillerBall extends MovingThing
{
    int hp=5;
    int dmg=5;
    public KillerBall()
    {
        setRotation(Greenfoot.getRandomNumber(360));
        int r=Greenfoot.getRandomNumber(56-dmg)+dmg;
        getImage().scale(r,r);
    }
    public KillerBall(int direction, int health)
    {
        setRotation(direction);
        hp=health;
        getImage().scale(getImage().getWidth()-health,getImage().getHeight()-health);
    }
    /**
     * Act - do whatever the Ball wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        move(3);
        if(atWorldEdge()){
            move(-3);
            turn(153);
        }
        bounce();
        getWorld().addObject(new Flame(),getX(),getY());
        destroy();
    }
    public void bounce()
    {
        if(canSee(Ball.class))
        {
            turn(189);
            //Greenfoot.playSound("Fire.wav");
            move(5);
        }
        if(canSee(KillerBall.class))
        {
            turn(145);
            //Greenfoot.playSound("Fire.wav");
        }
        if(canSee(AstroBall.class))
        {
            turn(178);
            //Greenfoot.playSound("Fire.wav");
            move(5);
        }
    }
    public void destroy()
    {
        Actor bullet;
        bullet = getOneObjectAtOffset ( 0, 0, Bullet.class );
        if(bullet != null)
        {
            int nhp=hp+dmg;
            //Greenfoot.playSound("Fire.wav");
            World world;
            world = getWorld();
            world.removeObject(bullet);
            Worldy worldy = (Worldy) getWorld();
            worldy.score(getImage().getWidth()*2);
            worldy.addPoints(getImage().getWidth()*2);
            if(nhp<50){
                getWorld().addObject(new KillerBall(315, nhp),getX()+10,getY()-10);
                getWorld().addObject(new KillerBall(45, nhp),getX()+10,getY()+10);
                getWorld().addObject(new KillerBall(135, nhp),getX()-10,getY()+10);
                getWorld().addObject(new KillerBall(225, nhp),getX()-10,getY()-10);
            }
            if(nhp==50){
                worldy.addD();
            }
            getWorld().removeObject(this);
        }
    }
}
