import greenfoot.Greenfoot;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.Date;

/**
 * Write a description of class SoundLooper here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class SoundLooper  
{
    
    private String soundFile;
    private String soundFile0 = null;
    
    private long miliseconds;
    private long miliseconds0 = -1;
    
    private int times = 0;
    private int timesSoFar = 0;
    
    private Date timeOfLoopEnd;
    
    private boolean playing = false;
    

    /**
     * Constructor for objects of class SoundLooper
     */
    public SoundLooper(String soundFile, long miliseconds) {
        this.miliseconds = miliseconds;
        this.soundFile = soundFile;
        playing = false;
    }
    
    public SoundLooper(String soundFile0, long miliseconds0, int times, String soundFile, long miliseconds) {
        this.miliseconds0 = miliseconds0;
        this.soundFile0 = soundFile0;
        this.times = times;
        this.miliseconds = miliseconds;
        this.soundFile = soundFile;
        playing = false;
    }

    public void loop() {
        if ( !playing || timeOfLoopEnd == null) {
            return;
        }
        Date timeNow = new Date();
        if (  timeNow.after(timeOfLoopEnd) ) {
            if ( (times > 0 && soundFile0 != null) && timesSoFar < times) {
                Greenfoot.playSound(soundFile0);
                timesSoFar++;
            }
            else {
                Greenfoot.playSound(soundFile);
            }
            timeOfLoopEnd = new Date(timeNow.getTime() + miliseconds);
        }
    }
    
    public void stop() {
        playing = false;
        timesSoFar = 0;
    }
    
    public void start() {
        if ( playing ) { 
            return;
        }
        timesSoFar = 0;
        playing = true;
        Date recentLoopStart = new Date();
        if ( soundFile0 != null ) {
            Greenfoot.playSound(soundFile0);
            timeOfLoopEnd = new Date(recentLoopStart.getTime() + miliseconds0);
            timesSoFar++;
        }
        else {
            Greenfoot.playSound(soundFile);
            timeOfLoopEnd = new Date(recentLoopStart.getTime() + miliseconds);
        }
        
    }

}
