import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)


import java.util.Calendar;
/**
 * Write a description of class Worldy here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Worldy extends World
{
    GreenfootSound music;
    public static final float FONT_SIZE = 48.0f;
    private Counter theCounter;
    private AstroCounter astCount;
    private BallMobile ballMobile;
    private Bullet bullet;
    private int Score=0;
    public Worldy()
    {
        super(900, 695, 1);
        music = new GreenfootSound("Bounce time.mp3");
        music.setVolume(15);
        theCounter = new Counter();
        addObject(theCounter,58,26);
        astCount = new AstroCounter();
        addObject(astCount,300,375);
        ballMobile = new BallMobile();
        addObject(ballMobile,Greenfoot.getRandomNumber(858)+21,Greenfoot.getRandomNumber(653)+21);
        prepare();
    }
    public void act()
    {
        pauseGame();
    }
    public void prepare()
    {
        Ball ball = new Ball();
        addObject(ball,Greenfoot.getRandomNumber(858)+21,Greenfoot.getRandomNumber(653)+21);
        
        GhostBall ghostBall = new GhostBall();
        addObject(ghostBall,Greenfoot.getRandomNumber(858)+21,Greenfoot.getRandomNumber(653)+21);
        
        KillerBall killerBall = new KillerBall();
        addObject(killerBall,Greenfoot.getRandomNumber(858)+21,Greenfoot.getRandomNumber(653)+21);
        
        AstroBall astroBall = new AstroBall();
        addObject(astroBall,Greenfoot.getRandomNumber(858)+21,Greenfoot.getRandomNumber(653)+21);
        
        AstroBall astroBall2 = new AstroBall();
        addObject(astroBall2,Greenfoot.getRandomNumber(858)+21,Greenfoot.getRandomNumber(653)+21);
        
        AstroBall astroBall3 = new AstroBall();
        addObject(astroBall3,Greenfoot.getRandomNumber(858)+21,Greenfoot.getRandomNumber(653)+21);
    }
    public void score(int newScore)
    {
        theCounter.add(newScore);
    }
    public void addD()
    {
        astCount.d++;
        astCount.a++;
        astCount.b++;
    }
    public void removeBullets()
    {
        bullet.life=0;
    }
    public void addPoints(int p)
    {
        ballMobile.points+=p;
    }
    public void scoreboard(int SCORE)
    {
        if (UserInfo.isStorageAvailable()) {//test to see if your data is avalable(logged in)  
            UserInfo myInfo = UserInfo.getMyInfo();// set myInfo to UserInfo  
            if (SCORE> myInfo.getScore()) //test to see if your score is better than your last  
            {  
                myInfo.setScore(SCORE);//set the score to your info  
                myInfo.store();// store the info  
            }  
        }
        addObject(new ScoreBoard(600, 600), getWidth() / 2, getHeight() / 2);
        Score=SCORE;
    }
    public void pauseGame()
    {
        if(Greenfoot.isKeyDown("p")){
            Greenfoot.stop();
        }
    }
    public void started() {
        music.playLoop();
    }
    public void stopped()
    {
        music.pause();
    }
}
