import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Ball here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class BallMobile extends MovingThing
{
    private int minGunFireDelay = 35;
    private int gunFireDelay = 0;
    int points = 0;
    private Vector acceleration = new Vector(0,0.3);
    
    public BallMobile()
    {
        setRotation(Greenfoot.getRandomNumber(360));
    }
    /**
     * Act - do whatever the Ball wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        bounce();
        move(3);
        if(atWorldEdge()){
            move(-3);
            turn(153);
        }
        if(Greenfoot.isKeyDown("left"))
            turn(357);
        if(Greenfoot.isKeyDown("right"))
            turn(3);
        if(Greenfoot.isKeyDown("space")) {
            fire();
        }
        if(Greenfoot.isKeyDown("down")) {
            fire();
        }
        gunFireDelay++;
        destroy();
    }
    public void bounce()
    {
        if(canSee(Ball.class))
        {
            turn(189);
            Greenfoot.playSound("Pop.wav");
            move(3);
        }
        if(canSee(GhostBall.class))
        {
            turn(189);
            Greenfoot.playSound("whoosh.mp3");
            move(3);
        }
        if(canSee(AstroBall.class))
        {
            turn(178);
            Greenfoot.playSound("Boop.wav");
            move(3);
        }
    }
    /**
     * Fire a bullet if the gun is ready.
     */
    private void fire() {     
        if(gunFireDelay >= minGunFireDelay) {
            Greenfoot.playSound("Bang.WAV");
            Bullet b = new Bullet(getRotation());
            getWorld().addObject(b, getX(), getY());
            b.move();
            gunFireDelay = 0;
        }         
    }
    public void destroy()
    {
        if(canSee(KillerBall.class)){
            Greenfoot.playSound("Fire.wav");
            gameOver();
            getWorld().removeObject(this);
        }
    }
    public void gameOver()
    {
        Worldy worldy = (Worldy) getWorld();
        getWorld().addObject(new GameOver(points),450, 375);
    }
}
