import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Bullet here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Bullet extends MovingThing
{
    /** A bullet looses one life each act, and will disappear when life = 0 */
    int life = 600;
    /** The damage this bullet will deal */
    private int damage = 16;
    
    public Bullet(int rotation)
    {
        setRotation(rotation);
        increaseSpeed(new Vector(rotation, 15));
    }
    public void act()
    {
        getWorld().addObject(new Flame(getImage().getWidth()/2, getImage().getHeight()/2, 2),getX(),getY());
        if(life <= 0) {
            getWorld().removeObject(this);
        } else {
            move();
            life--;
            if(atWorldEdge())
                getWorld().removeObject(this);
        }
    }
}
